<?php

namespace Controller;

use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\Controller\Exception;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Request;

/**
 * Created by PhpStorm.
 * User: erikasantos
 * Date: 29/12/2014
 * Time: 13:12
 */

class ResourceProject extends \Zeedhi\Framework\Controller\Simple
{

    protected $resourceProjectService;

    public function __construct(\Service\ResourceProject $resourceProjectService)
    {
        $this->resourceProjectService = $resourceProjectService;
    }

  /* public function saveResourceProjectPaths(Request\DataSet $request, Response $response){
        $param = $request->getDataSet()->getRows();
        $repository = $param[0]['REPOSITORY'];
        $directory = $param[0]['DIRECTORY'];
        $resourceProjectId = $param[0]['RESOURCE_PROJECT'];
        $projectId = $param[0]['PROJECT_ID'];
        $repositoryStatus = $param[0]['REPOSITORY_STATUS'];

        try {
            $this->resourceProjectService->setResourceProjectPaths($repository,$directory, $resourceProjectId,
                $projectId, $repositoryStatus);

        } catch (\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_WARNING));
        }
    }*/

    public function saveProjectDirectory(Request\DataSet $request, Response $response)
    {
        $param = $request->getDataSet()->getRows();
        $path = $param[0]['PATH'];
        $resourceProjectId = $param[0]['RESOURCE_PROJECT_ID'];

        try {
            $this->resourceProjectService->saveProjectDirectory($path,$resourceProjectId);
        } catch (\Exception $e) {
            $response->addMessage(new Response\Message($e->getMessage(), Response\Message::TYPE_WARNING));
        }
    }


    public function dataProjects(Request\Filter $request, Response $response)
    {
        $resourceProjectPaths = $this->resourceProjectService->getAllResourceProjectsPaths();
        $response->addDataSet(new DataSet('userDataProjects', $resourceProjectPaths));
    }

    public function saveDirectory(Request\DataSet $request, Response $response) {
        $param = $request->getDataSet()->getRows()[0];
        $repository = $param['REPOSITORY_ID'];
        $directory = $param['PATH'];
        $linuxDirectory = $param['LINUX_DIRECTORY'];
        if(isset($param['PATH_ID'])){
            $directoryId = $param['PATH_ID'];
        }else{
            $directoryId = null;
        }

        $resourceProject = $this->resourceProjectService->saveDirectory( $repository, $directory, null, $directoryId,$linuxDirectory);
        $response->addDataSet(new DataSet('resourceProjectsPaths', array($resourceProject->getId())));
        $response->addNotification(new Response\Notification('Diretório salvo com sucesso !'));
    }

    public function copyProjectPaths(Request\DataSet $request, Response $response) {
        $params = $request->getDataSet()->getRows()[0];
        $selectedPaths = $params['selectedPaths'];
        $project = $params['projectReceiver'];
        $this->resourceProjectService->copyDirectories($selectedPaths, $project);
    }

    public function verifyProjectPaths(Request\DataSet $request, Response $response){
        $params = $request->getDataSet()->getRows()[0];
        $selectedPaths = $params['selectedPaths'];
        $project = $params['projectReceiver'];
        list($successfulProjectPaths, $failedProjectsPaths) = $this->resourceProjectService->verifyProjectPaths($selectedPaths, $project);
        $response->addDataSet(new DataSet('verifyProjectPaths', array('failedProjectPaths' => $failedProjectsPaths,
            'successfulProjectPaths' => $successfulProjectPaths)));
    }

    public function bringProjectsPaths(Request\DataSet $request, Response $response)
    {
        $param = $request->getDataSet()->getRows();
        $user = $param[0]['USER'];
        $projectPaths = $this->resourceProjectService->getAllResourceProjectsPaths($user);
        $response->addDataSet(new DataSet('projectsPaths', $projectPaths));
    }

    public function bringResourceProjectsPaths(Request\Filter $request, Response $response) {
        $param = $request->getFilterCriteria()->getConditions();
        if(!empty($param[0]['value'])){
            $projectId = $param[0]['value'];
        }else{
            $projectId = null;
        }
        $resourceProjectPaths = $this->resourceProjectService->getAllResourcePaths($projectId);
        $response->addDataSet(new DataSet('resourceProjectsPaths', $resourceProjectPaths));
    }

    public function deleteDirectories(Request\DataSet $request, Response $response){
        $count = 0;
        $dataSet = $request->getDataSet()->getRows();
        foreach ($dataSet as $param){
            try{
                $this->resourceProjectService->deleteDirectory($param['PATH_ID']);
            }catch(\Exception $ex){
                $response->addMessage(new Response\Message(\Util\Messages::ERR_NOT_SUCCESSFUL_DELETED_EXPLANATION . $ex->getMessage()));
                $count--;
            }
            $count++;
        }
        $response->addNotification(new Response\Notification("$count diretório(s) deletado(s)."));
    }

}
