<?php
namespace Service\Calc\Strategy;
/**
*
* Intarface to calculate
* planed, spend, Remaining
*/
class HourCalcStrategyFactory{
	
	private $appropriationService;
	public function __construct(\Service\AppropriationInterface $appropriationService){
		$this->appropriationService = $appropriationService;
	}
	private $leafHourCalcStrategy;
	private $nodeHourCalcStrategy;

    /**
     * @param \Zeedhi\DevOps\Model\Projectmanagement\EntitiesInterface\Calc\TaskInterface $task
     * @return HourCalcStrategyInterface
     */
	public function factoryCalc($task){
		$strategy = $this->buildNodeHourCalcStrategy();
		if(!$task->hasChildren() && $task->getIsParent() != 'Y'){
			$strategy = $this->buildLeafHourCalcStrategy();
		}
		return $strategy;
	}

	private function buildNodeHourCalcStrategy(){
		if($this->nodeHourCalcStrategy == null){
			$this->nodeHourCalcStrategy = new NodeHourCalcStrategy();
		}
		return $this->nodeHourCalcStrategy;		
	}

	private function buildLeafHourCalcStrategy(){
		if($this->leafHourCalcStrategy == null){
			$this->leafHourCalcStrategy = new LeafHourCalcStrategy($this->appropriationService);
		}
		return $this->leafHourCalcStrategy;		
	}
}