<?php
/**
 * Created by PhpStorm.
 * User: eugeniofonseca
 */

namespace Service\Integration;


use \Teknisa\Model\Teknisa\Entities;
use Util\InstanceProvider;
use Zeedhi\DevOps\Model\Projectmanagement\Entities\Resource;

class IntegrationCP {

    public static function createCall($name,Resource $reportedBy,$description,$issueId,$projectId,$classificationId)
    {
        $call = InstanceProvider::getRepository()->getCpCall()->findOneBy(array('callRelationship'=> $issueId));
        if(!$call){
            $cdOperador = $reportedBy->getExternalCode();
            $call = self::factoryCall($name,$cdOperador,$description,$issueId,$projectId,$classificationId);
            $entityManager = InstanceProvider::getEntityManager();
            $entityManager->persist($call);
            $entityManager->flush();
        }
    }

    public static function factoryCall($reference, $reportedBy, $description, $callRelationship, $product,
                                       $classification)
    {
        $entity = new  Entities\CpCall();
        $entity->setReference($reference);
        if (!$reportedBy) {
            $reportedBy = 1;
        }
        $entity->setReportedBy($reportedBy);
        if (!$description) {
            $description = ' ';
        }
        $entity->setDescription($description);
        $entity->setType(Entities\CpCall::TYPE_ISSUE);
        $entity->setCallRelationship($callRelationship);
        $entity->setProduct($product);
        $entity->setClassification($classification);
        return $entity;
    }

}