function ZhWebWorker() {

	var worker;
	var listeners = [];

	this.create = function(url) {
		worker = new Worker(url);
		return this;
	};

	this.sendData = function(data) {
		worker.postMessage(JSON.stringify(data));
		this.notify({
			"action": "messageSent",
			"data": true
		});
	};

	worker.addEventListener('message', function(e) {
		e = JSON.parse(e.data);
		this.notify({
			"action": "messageReceived",
			"data": e
		});
	}.bind(this), false);

	this.addListener = function(listener) {
		//if it isn't there already, add it
		if (listeners.indexOf(listener) === -1) {
			listeners.push(listener);
		}
	};

	this.removeListener = function(listener) {
		//find 1st matching method's position
		var index = listeners.indexOf(listener);
		//if it was found...
		if (index > -1) {
			//...remove it from the array
			listeners.splice(index, 1);
		}
	};

	this.notify = function(message) {
		listeners.forEach(function(listener) {
			if (listener[message.action]) {
				listener[message.action](message.data);
			}
		});
	};

}

var ZhWorkerFactory = {
	create: function(url) {
		return new ZhWebWorker().create(url);
	}
};